ClanLib ChangeLog
-----------------

Version 1.0.0: Released April 2009
- Loads more bugs fixed

Version 0.8.1: Released March 2008

- MacOS: XCode 2.X projects added
- MacOS: Can now change resolutions on the fly
- GUI: CL_InputBox improved, supports system-wide cut-and-paste under MacOS and Windows
- GUI: RichEdit class added, currently only a very basic html style viewer
- Global: CL_Clipboard added
- ClanDisplay: .bmp loading support added
- ClanSound: ALSA support added
- Loads of bugs fixed

Version 0.8.0: Released August 5th 2006

  Minors:
  - ClanGUI: Misc mem leaks fixed
  - Global: Compiles under gcc 4.1 without errors
  - ClanDisplay: added CL_Sprite::get_angle_pitch() and CL_Sprite::get_angle_yaw() funtions
  - ClanDisplay: added CL_Surface::draw_subpixel() and CL_Sprite::draw_subpixel functions
  - ClanDisplay: added add_looping() function
  - ClanDisplay: added "fileseq" xml image sequence loading to CL_ResourceData_SpriteDescription
  - ClanGUI: added CL_FileDialog::set_behavior() function
  - ClanGUI: added CL_InputDialog::get_button()function
  - ClanGUI: CL_FileDialog now correctly processes typed filenames
  - ClanGUI: CL_FileDialog::get_path() functionality added
  - Global: Configure utility modified to work under VC8
  - Global: Key constants added/improved under all platforms
  - ClanDisplay: Fixed 8 bit palletized image bug in png loader
  - MacOS: Mouse wheel support added
  - MacOS: MacOS readme updated with info on building universal binaries
  - MacOS: Correctly handles switching between fullscreen/windowed mode
  

Version 0.8.0: RC1/RC2 Released 20th of Oct 2005
  Majors:
  - Global: Mac OSX support.
  - ClanGL: Pixelshader support.
  - ClanGL: OpenGL 2.0 support.
  - ClanDisplay: Collision outline resource support.
  - ClanDisplay: Support for saving PNG and JPEG files
  - ClanGUI: Performance fixes and nicer Silver theme.
  - ClanGL: Support for xinput (graphic tablets)

  Minors:
  - ClanGL: X11 fullscreen support mostly working again
  - ClanCore: Added clearing of nodes when CL_DomDocument::load() is called.
  - ClanCore: Added CL_DomDocument::clear_all() function.
  - ClanCore: Fixed incorrect is_null() function in smart pointers.
  - ClanCore: Added <include> tag to resources.
  - ClanDisplay: Fixed crash in collision detection outline generation code.
  - ClanDisplay: Two formats in CL_PixelFormat had wrong size parameter.
  - ClanDisplay: CL_PixelBuffer cleanup, no more pointer and 'delete_provider' mess
  - ClanDisplay: CL_Display::get_buffer()/CL_GraphicContext::get_pixeldata() fixed, making screenshot is now easy and works
  - ClanGL: Added triangle drawing.
  - ClanGL: Glx resize fix.
  - ClanGUI: Constructing CL_TreeView from XML GUI definition is now possible.
  - ClanGUI: Buttons can now use images on top of the theme.
  - ClanGUI: Windows can now optionally have close, maximize, minimize, help buttons on titlebar.
  - ClanSDL: Keyboard fixes.
  - ClanMikMod: Support for MikMod 3.2.
  - Global: Memleak fixes.
  - Build: Fixes to the build system.

Version 0.7.8: Released 10th of May 2004
  Majors:
  - ClanDisplay: Replaced Hermes with internal converter routines.
  - ClanDisplay: Added stateless drawing commands on CL_Surface.
  - ClanDisplay: Added collision detection.
  - ClanDisplay: Added two new rotates to surfaces/sprites: pitch and yaw. Makes creating isotiles very easy.
  - ClanDisplay: Added new alpha cutter, which works in a "free" mode.
  - ClanSDL: Improved drawing of surfaces.
  - ClanCore: Added CL_WeakPtr.
  - ClanCore: Added CL_LineMath and CL_TriangleMath.
  - ClanLib: Modified ClanLib internals to use CL_SharedPtr instead of manual reference counting,
             and fixed other memory leaks.
  - ClanGUI: Fixed and updated CL_Image.
  - ClanGL: WGL implementation now also use settings from CL_OpenGLWindowDescription.
  - Examples: Added SpritesRTS example.
  - Docs: New Collision overview.

  Minors:
  - ClanDisplay: Implemented sig_key_dblclk under win32.
  - ClanDisplay: Added 'interval' flag to flip() so vsync can be controlled by application.
  - ClanDisplay: Fixed font to use CL_GraphicContext parameter for draw commands.
  - ClanDisplay: Changed surface providers to be more loyal to the original input pixel format.
  - ClanDisplay: Made CL_Sprite::get_height() actually return the height instead of the width.
  - ClanDisplay: Made all surface providers load their image in the constructor instead of calls to lock().
  - ClanDisplay: Fixed CL_InputEvent::repeat_count under win32.
  - ClanDisplay: Added support for frame offset in sprites.
  - ClanDisplay: Fixed restart of sprites.
  - ClanDisplay: Added optional persistent pixelbuffer in surfaces (CL_Surface::get_pixeldata).
  - ClanDisplay: Fixed set_cursor shutdown crash.
  - ClanDisplay: Fixed linux canvas.
  - ClanDisplay: Fixed CL_DisplayWindow to always use client area sizes.
  - ClanGL: Fixed memory leak in CL_OpenGLState.
  - ClanGL: Casts of all OpenGL functions because Linux is a toy OS.
  - ClanSound: Made fragment size 2048 (a power of 2). Fixes sound output on some broken audio drivers.
  - ClanVorbis: Added loading of entire ogg file into memory to fix mixing issues on slow HD/IDE systems
                (all Dell's I've ever seen!).
  - ClanSignals: Fixed calling of slot for signal_v0 even when the CL_Slot has been deleted.
  - ClanSignals: Fixed memory leak situation when slots are added and removed to a signal never emitted.
  - ClanGUI: Made CL_ComponentManager delete its components when destroyed.
  - ClanGUI: Added custom component support to TreeItem.
  - ClanGUI: Added CL_Button::is_drawn_down().
  - ClanGUI: Fixed is_enabled() and is_visible() checks, this fixes disabled children of a component.
  - ClanGUI: Fixed CL_Frame use in xml, and filling in drawing.
  - ClanGUI: Added CL_Rect constructor to CL_Menu.
  - ClanGUI: Fixed sig_lost_focus problem when using remove_child.
  - ClanGUI: Fixed password mode for silver theme.
  - ClanCore: Improved CL_SharedPtr to allow incomplete type everywhere but on construction.
  - ClanCore: Improved CL_String::tokenize and CL_String::get_path.
  - ClanCore: Crash Reporter now enabled for VC2002 and 2003 again.
  - ClanVoice: Removed this unfinished module (it's now located in ClanPrototypes CVS module).
  - ClanJavascript: Removed this unfinished module (it's now located in ClanPrototypes CVS module).
  - ClanNetwork: Removed unfinished Browse classes (they are now located in ClanPrototypes CVS module).
  - ClanNetwork: Fixed deadlock that could occur when sending netpacket from another network signal.
  - Build: Updated Mandrake Spec (RPM) file.

Version 0.7.7: Released 10th of January 2004
  Majors:
  - ClanDisplay: Added linux pbuffer support (canvas).
  - ClanDisplay: Added stencil testing.
  - ClanGL: Replaced begin_3d/end_3d with CL_OpenGLState.
  - ClanGL: Added OpenGL 1.4 wrappers (ClanLib/GL/opengl_wrap.h)
  - ClanGL: Added CL_OpenGLWindowDescription.
  - ClanGUI: Added TreeView.
  - ClanGUI: Added advanced layout management.
  - ClanNetwork: Added UDP support.
  - Docs: New Display overview.
  - Docs: New OpenGL overview.

  Minors:
  - ClanCore: Updates to CL_Directory and CL_DirectoryScanner.
  - ClanDisplay: Fixed upside down issue with CL_Surface::get_gc().
  - ClanDisplay: Fixed linux crash if no available display modes were found.
  - ClanDisplay: Fixed certain cases of crash when the app was minimized.
  - ClanDisplay: Fixed inverse cliprects causing strange clipping.
  - ClanGL: Added CL_LightSource glLight container class.
  - ClanGL: Added CL_Viewpoint helper class.
  - ClanSound: Made session object default to the volume/pan from the soundbuffer.
  - ClanNetwork: Made it ignore SIGPIPE's.
  - ClanNetwork: Fixed warnings about "comparison is always false due to limited range of data type".
  - ClanGUI: Fixed positioning of menus, and added popupmenus.
  - ClanGUI: Updated FileDialog.
  - ClanGUI: Added checkbox to InputDialog.
  - ClanGUI: Added menu creation convenience functions.
  - ClanGUI: Now possible to query InputDialog for resultbutton.
  - ClanGUI: Added support for MDI windows.
  - ClanGUI: Fixed shadow clipping of CL_Windows.
  - ClanGUI: Added min/max/preferred size attributes to CL_Component.
  - Build system: Lots of improvements for mingw and cross platform compiling.
  - Examples: Added BlendFunctions, showing the effect of blend functions available.
  - Examples: Added Canvas, showing destructable terrain.
  - Examples: Added GLGUICube, demonstrating OpenGL and GUI together.
  - Examples: Added IRCBot, shows how to use CL_IRCConnection to connect to a channel.
  - Examples: Added TreeView, showing how to use CL_TreeView.
  - Examples: Added menus to GUIWindow example.
  - Examples: Modified screenshot example.
  - Examples: Added stencil example.
  - Docs: New reference doc generator.
  - Docs: Updated Signal & Slots overview with Userdata and Disconnect.
  - Docs: Fully documented XML reference docs.

Version 0.7.6: Released 11th of November 2003
  - ClanCore: Added eat_whitespace and insert_whitespace flags to XML reading and writing.
  - ClanCore: Fixed CL_DomDocument::get_document_element() to return first element instead of first node.
  - ClanCore: Only VC7 will compile crashreporter to avoid all the problems vc6 users get.
  - ClanDisplay: Added Linux joystick support.
  - ClanDisplay: Added Linux support for multiple usb mice.
  - ClanDisplay: Added joystick support to CL_InputDevice and CL_InputEvent.
  - ClanDisplay: Added pbuffer support. CL_Surface::get_gc() should work now with OpenGL target in Windows.
  - ClanDisplay: Added usage of wglShareLists in Windows so that textures are shared between opengl contexts.
  - ClanDisplay: Implemented CL_Mouse::set_position() on X11.
  - ClanDisplay: Implemented CL_Surface::set_pixeldata().
  - ClanDisplay: Added support for animated mouse cursors.
  - ClanDisplay: Mouse wheel events fire on both key_down and key_up.
  - ClanSound: Made it use CL_SoundOutput volume and pan settings.
  - ClanSound: Fixed INITGUID linker error some would get under win32.
  - ClanGL: Made GL state checker bind texture after a flush(), to fix issue with begin_3d/end_3d.
  - ClanGUI: Added topmost flag.
  - ClanGUI: Added menus.
  - Examples: Added PilotsPuzzle example.
  - Examples: Extended MousePoll example showing an animated mouse cursor.
  - Examples: Extended Joystick example with new functionality.
  - Docs: New overview: Post-Mortem Debugging using the ClanLib Crash Reporter.
  - Build: Many MingW fixes.
  - Build: Win32 configure program - Added Visual C++ 7.0 project files generation (sln, vcproj).
  - Build: Win32, changed from brute force linking into using pragma linking hints. This will
    remove alot of those warnings when compiling ClanLib.
  - Build: win32, removed "A subdirectory or file ... already exists." warnings when compiling ClanLib.

Version 0.7.5: Released 16th of October 2003
  - ClanGUI: We threw away our proprietary gui format, and now use XML instead.
    You can now even mix standard ClanLib resources and GUI definitions in the same file.
  - ClanGUI: Fixed FileDialog to return proper filename.
  - ClanCore: Added CrashReporter - making it possible to debug crashes in release-builds.
  - ClanCore: CL_Thread fixes.
  - ClanDisplay: Win32 Fullscreen is working again.
  - ClanDisplay: Joystick is now working.
  - ClanDisplay: Added missing CL_Mouse::set_cursor.
  - ClanDisplay: Fixed the X11 keyboard event return getting pressed and released.
  - ClanDisplay: Added framerate counter class - CL_FramerateCounter.
  - ClanDisplay: Fixed resize flag not getting set in Win32.
  - ClanSound: Fixed filters.
  - ClanVorbis: Fixed looping.
  - ClanMikMod: Fixed looping.
  - ClanNetwork: IRC updates.
  - ClanSDL: Now available under VC7.
  - ClanGL: Fixed CL_Display::clear().
  - ClanGL: Fixed set_color() in sprite, surface, etc.
  - Examples: Many CTalk (IRC Client) updates.
  - Examples: Many GUIScript updates.
  - Examples: Added Joystick.
  - Examples: Added SoundFilters.
  - Examples: Added Time, demonstrating CL_FramerateCounter, CL_Timer, CL_System::get_time etc.
  - Docs: New overview: Sound - Samples and Music.
  - Docs: New overview: GUI - XML Resources.

Version 0.7.4 - Released 18th of September 2003
  - ClanGL: Optimization using vertex arrays: Up to 1.5x speed increase!
  - ClanDisplay: Texture packer fixed to use max texture size supported by gfx card.
  - ClanCore: CL_CommandLine: a getopt_long() style command line parser.
  - ClanCore: CL_System::get_exe_path(): return the location of your binary.
  - ClanCore: CL_Log now has a severity argument.
  - ClanSignals: Added functor support.
  - ClanGUI: Minor ClanGUI fix when using components with automatic size.
  - ClanGUI: Added CL_Component::sig_close, making it possible to override the closing of CL_Window.
  - Examples: Added GUIStyle, demonstrating the powerful ClanGUI themeing.
  - Examples: Added GUIWindow, demonstrating how to override default window closing.
  - Examples: Added CommandLine, demonstrating the new commandline functionality.
  - Examples: Added ExePath, demonstrating the new exepath functionality.
  - Docs: Misc overview updates (Signals, GUI Theming).
  - Build: fixed .so version issues, preparations to allow stable and
    devel versions to coexist in the future.
  - Build: lots of fixes and cleanups.

Version 0.7.3 - Released 6th of September 2003
  - Resources are now setup via XML
  - clanSDL, classic software 2d support is back
    (This is a limited target which cannot do all the nice things the opengl target can do - just basic 2d)
  - Lots of cleanups in the Linux auto* build system
  - MinGW and cross-compile support (see INSTALL.mingw)
  - clanSound fixes
  - New CL_SoundBuffer constructor: CL_SoundBuffer(const std::string &filename);
  - All examples now compile and run
  - Updated documentation with cooler reference and loads more overviews
  - Many ClanNetwork fixes
  - Many OpenGL optimizations
  - Lots of minor fixes throughout ClanLib

Version 0.7.2 - Released 25th of February 2003
  <file not updated, basically lots of even cooler stuff>

Version 0.7.1
  <file not updated, basically lots of cool stuff>

Version 0.7.0 - Released 2nd of November 2002
  - Started theme for ClanDisplay2
  - Started theme for ClanDisplay1	
  - Moved Default theme out from ClanGUI
  - Automake/libtool support
  - Added new disp2 test (example)
  - initial 0.7.0 RPM specs
  - hooking up new Hermes (inverse alpha) functionality (when available)
  - backported changes from 0.6.1 into 0.7.x 
  - Mouse enter/leave behaviour changed. Will now emit them also in mouse
    capture.
  - GUIEditor load dialog implementation & fixes
  - Fixed listbox resizing
  - Started reimplementing popupmenues - now clean & solid
  - Some voice API planning.
  - Start of a sprite overview
  - Fixed a sprite resource bug
  - Added GraphicContext get_width() and get_height()
  - Added Sprite example
  - Added Image provider class factory API.
  - Added Sprite Resource things
  - Start of a GUI Theme overview
  - Added kdevelop readme
  - merged clandisp2 and network2 into 0.7.x

Version 0.6.3 - RELEASED (August 5th 2002)
  - Fixed windows compile bug that sneaked into 0.6.2.

Version 0.6.2 - RELEASED (August 2nd 2002)
  - DirectFB updates.
  - Misc minor bug fixes.

Version 0.6.1 - RELEASED (April 7th 2002)
  - endian fixes in datafilecompiler, targa & wave provider
  - fixed CXX/CFLAGS not being substituted by configure
  - updated INSTALL.linux/win32, PATCHES, rpm specs (forgot in 0.6.0)
  - added UPDTunnel makefile for linux
  - fix for bug [ 537560 ] X11 fullscreen crash on shutdown

Version 0.6.0 - RELEASED (April 1st 2002) - "April Fools Release"
  - gui inbox Fixed possible out-of-bounds -1 case for the cursor_position
    variable.
  - shared lib version is now 2! (in order to have a 0.5.x & 0.6.x install possible)
  - rpm spec update for Mandrake 8.2
  - png provider bugfix (arrays start by 0, not 1)
  - Stripped down default gui theme (removed unused elements), and moved
    it into GUIThemeDefault directory.
  - Added checked_disabled and unchecked_disabled to radiobuttons and checkbuttons-
    GUI apps using the default theme should now use the new GUIThemeDefault files.
  - Cleaned up the GUI examples.
  - some compile fixes and memory leak patches
  - documentation generation bugfix (filenames with :: now contain __)
  - !NEW! MSVC will now *automagically* link in the right .lib depending on the ClanLib API files you include
  - Fixed TreeView open/collapse bug
  - Added some more functions to nodes and items to make it all more accessible
  - Fixed radiogroup selection signal
  - Renamed some classes as well (CL_ListBox_Item -> CL_ListItem ++)
  - fixing documentation 'uncategorised' classes
  - repeated building docs will now only generate docs once (because everything already exists ofcourse)
  - adding signal dependency for examples 
  - Removed alot of functionality from StyleManager_Default which wasnt used
  - Fixed SoundSound bug in Configure app
  - Applied DirectFB patch for DirectFB 0.9.9
  - Memory debugging fix for ResourceOptions
  - ClanGUI: adding RadioButtons support
  - CL_Input fix with get_button(0)
  - adding annotation support for the docs (for putting on a website with php support)
  - OpenGL get_proc_address (linux & win32). 
  - Fixed the ASM problem reported by Filip.
  - Configure App fixes for generating installation batchfiles (per 'module')
  - DirectSound recording support.
  - Added some ClanGUI component constructors to make them more consistent
  - Updated the gui-status file
  - Components now only respond to left mouse button and not all
  - Changed the input signals in clanGUI again - sorry guys, but
    this really cleaned it up to the better - read README.upgrade
    as usual for more specifics
  - applying darryl's memory leak bugfixes + some small memory
    leaks / uninitialised memory reads we found
  - More font updates, for those that dont read everything in detail.
  - CL_Component: Changes sig_key_up/down to only handle keyboard
  - CL_Component: Added sig_input_up/down
  - ClanGUI: CL_ScrollBar - Fixed scrolling bug
  - ClanGUI: CL_ScrollBar - Fixed resize bug
  - ClanGUI: Updated component-status (readme.gui)
  - Moved streamed soundprovider sessions to clanSound mixing thread.
    This should make music continue to play during loading and other cases
    where CL_System::keep_alive() is not heart-beat often enough.
  - ClanGUI: Improved mouse capture code
  - ClanGUI: small linux fix for snprintf
  - ClanGUI: Added new CL_Window constructor (without size)
  - Fixed component_at: now searching from top-level components and down
  - sig_mouse_down/up are now signalled
  - applied [ #485196 ] X11 keypad support
  - Partly/manually applied [ #484817 ] makefile (distclean) patches
  - small cleanup of Makefiles
  - ClanGUI: Slightly different lost_focus behaviour
  - Made all signals consistent - please read README.upgrade for more specific info.
  - Updated signals & slots overview with CL_SlotContainer and misc
  - Fixed some input bugs where some signals werent signalled.
  - Applied buffer overrun patch

Version 0.5.4, January 22 2002
  - Datafile & resource fixes (Everything should work again with datafiles!)
  - Added a CL_Setup???::init(bool register_resources_only = false)
    which makes it possible to compile datafiles without initializing the devices (display, sound, etc).
  - CL_Font::print_center and print_right is now also multi-line enabled
  - Fullscreen possible under GLX
  - Win32 CL_System::get_time() performance fix
  - X11 put_display fix
  - ClanTTF: Compile fix
  - ClanPNG: is_indexed() in PNG-files now return correct value
  - ClanNet: Backported sockets from ClanNet2 (fixes some bugs)
  - ClanGUI: Added "tab next" support
  - ClanGUI: Added "tab id" support
  - ClanGUI: Fixed automatic sizing of CL_CheckBox
  - ClanGUI: Fixed keyboard and mouse event routing.
  - ClanGUI: Removed many memory leaks from components

Version 0.5.3, January 10 2002
  - Fixed resource path bug introduced in 0.5.2
  - Default videomode is windowed, and not fullscreen.
  - Resource-overview updates
  - Linux configure fix
  - Fixed CL_DirectoryScanner
  - ClanPNG Makefile fix for installing

Version 0.5.2, January 08 2002
  - Fixed CL_TreeView
  - Added set_text(num) to CL_InputBox
  - Fixed CL_Sleep() in Linux
  - Added support for thread null handles
  - Removed CL_CreateSlot
  - Many many updates to GUIEditor example
  - New GUI overview
  - Added raw datatype input source interface
  - Allowed resource inheritance from other resource managers
  - Added CL_SlotContainer
  - GUI Reference documentation updates
  - Replaced 'const char *' with 'std::string &' all over clanlib.
    NOTE: this breaks binary API compatibility with previous 0.5.x binaries
  - Added typesafe get_component template function (for GUI)
  - Fixed msvc++ configure.
  - Added datatype enum to componentype options
  - memory leak fixes (unix display)
  - clanLua fixes (requires tolua to be present + added more detailed explanation)
  - Eventtrigger (bugfix + make assignments of CL_EventTrigger safe)
  - removed CL_MPEG
  - GCC 3 fixes
  - DDFLIP_VSYNC only enabled on versions of DX that has the flag.
  - added directory scanner API & first implementation (win32 & unix)
  - CL_Button in ClanGUI now only activates on space and mouse
  - CL_InputDevice::get_type() added
  - Added CL_SetupCDAudio.
  - Fixed horiz/vert flipping.
  - ClanNetwork: leave and rejoin now throws exceptions as join does.
  - DirectDraw DDFLIP_NOVSYNC flag support in flip_display() (Enabled if using DirectX 8).
  - Much more precise CL_System::get_time() timer.
  - Added directory scanner API.
  - Added CL_SetupVorbis.
  - Fixed redirect console stuff for Borland.
  - Added IPv6 support for clanNetwork. Just define IPV6 and you're good to go.
    This should be noted as a development only feature. (Who has got IPV6 anyway?)
  - Added experimental clanJavaScript.
  - ClanSound volume fix.
  - Fixed inputsource file provider path issues.
  - Added resource locations to be relative to resource file.
    (See also README.upgrade for more info!).
  - CL_ListBox fixes (multiselection, trigger bug on empty lists).
  - Significant updates to ClanFTP, much more robust now.
  - Fixed CL_Surface resource unloading. 
  - Memory leak fixes (font ttf, generic resource font, surface, resource manager, display target, console window,
    input mouse, setupdisplay windows).
  - Win32 install doc added linkage troubleshooting.
  - Fixed bug [ #472042 ] mikmod example never exits
  - Fixing [ #472571 ] can't turn off mikmod reverb, by disabling
    mikmod reverb by default.
  - Redhat spec update
  - Borland C++ fixes (typecasts, etc, Makefile generator)
  - NetObjects example update (send team info upon connect, voodoo replication,
    LobbyPlayer, no team switch after ready player, uninited players, 
    return to lobby in game, auto-join least populated team, correct replication,
    force set name before join, cleanup - STILL NOT PLAYABLE, THOUGH)
  - Reference documentation (small fix).
  - fixed bugs in CL_NetComputer_Host and CL_UniformSocket get_address() 
    and get_port() not giving correct address and port.
  - DirectFB patch applied.

Version 0.5.1, November 01 2001
  - moved Mandrake spec to seperate RPM/Mandrake directory
  - added NetObjects TODO
  - fixed nvidia GL detection (test program linker error pthread)
  - disabled win32 clanLua & examples support for 0.5.2
  - Resource manager fixes (ASCII, tolower,etc)
  - Overview index update
  - GUI overview updates
  - Applied Harrys GLX patch
  - Start of a new overview: Signals & Slots
  - NetObjects added a wormhole (eyecandy + source) 
  - NetObjects added placeholder intro with some placeholder sounds (thanks to
    XenoHammer project)
  - more docpatches
  - NetObjects new inputbox gfx + README update from mbn
  - more NetObjects work (waitingroom is now Lobby, chatting works, etc)
  - CL_Target updates to fix flip_horiz/vert.
  - Fixed 'internal compiler error' issue with msvc++. CL_ThreadFunc_v0..3 are
    now macroes instead of template functions.
  - mbn added 15 new bugs
  - fixed listbox::set_top_item check range & update scrollbar -> 
    still some other strange drag & drap scrollbar problem exists
  - spec updates (building GL rpm, etc)
  - NetObjects example has completely new GUI look & feel
  - NetObject example work (speed update, added initial waitingroom, 
    additional control style implementations)
  - fixed GUI scrollbar 
  - fixed win32 playcd not playing CD
  - fixed bug [ #471387 ] canvas sample doesn't display correctly
  - Resources are no longer case-sensitive. Fixes bug #460036
  - PCX transparency works fine: Bug #463883
  - bugfix in ClanTTF causing crash in destruction
  - MAJOR example updates (makefiles, readmes, comments, warnings, etc.. 
    etc.., too much to summarize - see Changelog on what happened today) 
  - added spec files for redhat, mandrake and conectiva
  - applied some patches from mandrake RPMS
  - Added CL_Socket.input and CL_Socket.output
  - fix for network reference bug
  - fixed several gcc warnings
  - png example added
  - documentation makefile updates
  - lots of Network documentation updates
  - Initial CL_ThreadFunc stuff.
  - New DSP: CompileAll, which compiles all modules (easy for testing :)
  - Documentation updates for 0.5.1
  - Fixes for PCE2 choking when parsing some classes.
  - Main doc page update
  - FAQ update
  - added GUI TreeView
  - Fixed nasty memory leak in static soundbuffers.
  - fixed bug [ #462039 ] ClanFTP build broken in win32
  - BPR makefile generator sucks much less now.
  - applied patch [ #465837 ] win32 - makes keypad keys available
  - Added push-back support for socket class.
  - applied patch [ #464890 ] fix for bug 464261(win32 joysticks)
  - applied patch [ #464893 ] fix for bug 464889 (win32 argv)
  - screenshot example with png support
  - added readmes for several examples (more should follow)
  - mous example bugfix 
  - more documenting patches
  - fixed bug [ #462040 ] MikMod exampel fails to build 
  - fixed bug [ #462049 ] streamsoundprovider crashes on exit 
  - borland makefile generator rewrite
  - more documentation updates
  - vector rewrite
  - random iterator optimizations
  - (win32) added clanDisplay precompiled header support	
  - (win32) example intermediate files are not shared any mor
  - fixes in (clanlib) mikmod & friends
  - fixed eventlistener
  - debian build fixes
  - fixed memory input source bug
  - lots of documentational updates (generating reference docs, etc)
  - borland updates
  - fixed linux network compile problem
  - lots of updates in CTalk example 
    NOTE:: [HERMES_CVS] bugfixes -> need to update hermes news & build new snapshots!!!
  - fixed network memory leak
  - added net socket overview documentation
  - ClanFTP & example has been added (clanNetwork)
  - browsemaster/connection implementation (clanNetwork)
  - NetBrowse example added (Documentation/Examples)
  - inputsource provider path fixes (clanCore)
  - NetVariables added (clanNetwork)
  - FreeBSD cd audio fix (clanSound)
  - some small OST (Nokia Media Terminal) patches
  - soundbuffer session reference counting added (clanSound)
  - misc control improvements (clanGUI)
  - filedialog improvements - works in unix too now (clanGUI)
  - DirectFB display target added (clanDisplay)
  - network improvements (clanNetwork)
  - more consistency across examples (Documentation/Example)
  - Resource management improvements (clanCore)

Version 0.5.0, April 28 2001
  - official development release of the 0.5.x tree
